package gov.lbl.nest.common.monitor;

import java.lang.reflect.Constructor;
import java.util.Map;
import java.util.ServiceLoader;
import java.util.UUID;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * This class is used to capture instrumentation data for a component.
 *
 * @author patton
 */
public abstract class Instrumentation {

    // public static final member data

    /**
     * The {@link Instrumentation} implementation that does nothing.
     */
    public final static Instrumentation NULL_INSTRUMENTATION = new Instrumentation() {

        @Override
        public void end() {
            // Do nothing.
        }

        @Override
        public void end(Map<String, String> attributes) {
            // Do nothing.
        }

        @Override
        public void end(UUID uuid,
                        Map<String, String> attributes) {
            // Do nothing.
        }

        @Override
        public void error(int status) {
            // Do nothing.
        }

        @Override
        public void error(int status,
                          Map<String, String> attributes) {
            // Do nothing.
        }

        @Override
        public void error(int status,
                          UUID uuid,
                          Map<String, String> attributes) {
            // Do nothing.
        }

        @Override
        public void pointOfInterst(String name) {
            // Do nothing.
        }

        @Override
        public void pointOfInterst(String name,
                                   Map<String, String> attributes) {
            // Do nothing.
        }

        @Override
        public void pointOfInterst(String name,
                                   UUID uuid,
                                   Map<String, String> attributes) {
            // Do nothing.
        }

        @Override
        public void start() {
            // Do nothing.
        }

        @Override
        public void start(Map<String, String> attributes) {
            // Do nothing.
        }

        @Override
        public void start(UUID uuid,
                          Map<String, String> attributes) {
            // Do nothing.
        }
    };

    // protected static final member data

    // static final member data

    /**
     * The {@link ServiceLoader} instance that will load the {@link Instrumentation}
     * implementation.
     */
    private final static ServiceLoader<Instrumentation> instrumentationLoader = ServiceLoader.load(Instrumentation.class,
                                                                                                   Instrumentation.class.getClassLoader());

    // private static final member data

    /**
     * The {@link Logger} used by this class.
     */
    private static final Logger LOG = LoggerFactory.getLogger(Instrumentation.class);

    // private static member data

    /**
     * true if the implementation class of Instrumentation has been logged.
     */
    private static boolean logged = false;

    // private instance member data

    // constructors

    // instance member method (alphabetic)

    /**
     * Creates an instance of the {@link Instrumentation} class.
     *
     * @param clazz
     *            the {@link Class} whose name will form the basis for all event
     *            types generated by the resulting {@link Instrumentation} instance.
     *
     * @return the created instance of the {@link Instrumentation} class.
     */
    public static Instrumentation getInstrumentation(Class<?> clazz) {
        return getInstrumentation(clazz.getName());
    }

    /**
     * Creates an instance of the {@link Instrumentation} class.
     *
     * @param name
     *            the name that will form the basis for all event types generated by
     *            the resulting {@link Instrumentation} instance.
     *
     * @return the created instance of the {@link Instrumentation} class.
     */
    public static Instrumentation getInstrumentation(String name) {
        for (Instrumentation instrumentation : instrumentationLoader) {
            final Class<?> clazz = instrumentation.getClass();
            try {
                final Constructor<?> constructor = clazz.getConstructor(String.class);
                Instrumentation result = (Instrumentation) constructor.newInstance(name);
                if (!logged) {
                    LOG.info("Using \"" + clazz.getCanonicalName()
                             + "\" as Instrumentation implementation");
                    logged = true;
                }
                return result;
            } catch (Exception e) {
                return null;
            }
        }
        if (!logged) {
            LOG.info("Using NULL as Instrumentation implementation");
            logged = true;
        }
        return NULL_INSTRUMENTATION;
    }

    /**
     * Called when this item being instrumented successfully completes its
     * responsibilities.
     */
    public abstract void end();

    /**
     * Called when this item being instrumented successfully completes its
     * responsibilities.
     *
     * @param attributes
     *            other attributes to associated with the start.
     */
    public abstract void end(Map<String, String> attributes);

    /**
     * Called when this item being instrumented successfully completes its
     * responsibilities.
     *
     * @param uuid
     *            the {@link UUID} instance associated with this end
     * @param attributes
     *            other attributes to associated with this end.
     */
    public abstract void end(UUID uuid,
                             Map<String, String> attributes);

    /**
     * Called when this item being instrumented unsuccessfully completes its
     * responsibilities.
     *
     * @param status
     *            negative values indicating failures, and positive values
     *            indicating something in between success and failure.
     */
    public abstract void error(int status);

    /**
     * Called when this item being instrumented unsuccessfully completes its
     * responsibilities.
     *
     * @param status
     *            negative values indicating failures, and positive values
     *            indicating something in between success and failure.
     * @param attributes
     *            other attributes to associated with the start.
     */
    public abstract void error(int status,
                               Map<String, String> attributes);

    /**
     * Called when this item being instrumented unsuccessfully completes its
     * responsibilities.
     *
     * @param status
     *            negative values indicating failures, and positive values
     *            indicating something in between success and failure.
     * @param uuid
     *            the {@link UUID} instance associated with this error.
     * @param attributes
     *            other attributes to associated with this error.
     */
    public abstract void error(int status,
                               UUID uuid,
                               Map<String, String> attributes);

    /**
     * Called when this item being instrumented has a self-defined point of
     * interest.
     *
     * @param name
     *            the name to use to define this point of interest.
     */
    public abstract void pointOfInterst(String name);

    /**
     * Called when this item being instrumented begins its responsibilities.
     *
     * @param name
     *            the name to use to define this point of interest.
     * @param attributes
     *            attributes to associated with this point of interest.
     */
    public abstract void pointOfInterst(String name,
                                        Map<String, String> attributes);

    /**
     * Called when this item being instrumented begins its responsibilities.
     *
     * @param name
     *            the name to use to define this point of interest.
     * @param uuid
     *            the {@link UUID} instance associated with this point of interest.
     * @param attributes
     *            attributes to associated with this point of interest.
     */
    public abstract void pointOfInterst(String name,
                                        UUID uuid,
                                        Map<String, String> attributes);

    /**
     * Called when this item being instrumented begins its responsibilities.
     */
    public abstract void start();

    // static member methods (alphabetic)

    /**
     * Called when this item being instrumented begins its responsibilities.
     *
     * @param attributes
     *            other attributes to associated with this start.
     */
    public abstract void start(Map<String, String> attributes);

    /**
     * Called when this item being instrumented begins its responsibilities.
     *
     * @param uuid
     *            the {@link UUID} instance associated with this start.
     * @param attributes
     *            other attributes to associated with this start.
     */
    public abstract void start(UUID uuid,
                               Map<String, String> attributes);

    // Description of this object.
    // @Override
    // public String toString() {}

    // public static void main(String args[]) {}
}
